EDIT - bug #9814

Advanced search webservice for area throws NPE (mexico portal)
10/18/2021 11:58 AM - Andreas Miiller

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.28

Severity: critical Found in Version:

Description

... Die Area-Terme in der Suche fehlen gerade komplett, das der Webservice nichts zurtckliefert:
https://132.248.13.83/cdmserver/cdm_flora_mexico/description/namedAreasinUse.json?includeAllParents=true&pagelndex=0&page
Size=500 :

98 common frames omitted Caused by: java.lang.NullPointerException: null at eu.etaxonomy.cdm.p
ersistence.dto.TermDto.getVocRepresentation_L10n_abbreviatedLabel (TermDto.java:154) ... 108 common
frames omitted

Das ist offensichtlich ein Bug im TermDto, bis dieser behoben ist sollten wir darauf achten, dass fur alle Area-Terme das
abbreviatedLabel angegeben ist.

Associated revisions

Revision d4542f66 - 10/18/2021 02:06 PM - Andreas Miiller
ref #9814 fix NPE in TermDto.getVocRepresentation_L10n (+..._abbreviatedLabel)

Revision dfd8da23 - 10/21/2021 09:29 AM - Katja Luther
ref #9814: add vocDto to termDto

Revision 4af8adcf - 10/26/2021 02:01 PM - Katja Luther
ref #9814: rename findByTitleasDto method to findByTitleAsDtoWithVocDto

Revision 13866815 - 10/26/2021 02:03 PM - Katja Luther
ref #9814: adapt method in editor

Revision 15966b - 10/26/2021 04:31 PM - Andreas Miiller

ref #9814 cache vocabularyDtos when loading termDTOs

Revision cb291ebd - 10/26/2021 04:48 PM - Andreas Miiller

ref #9814 fix vocabularyDtos caching

History

#1 - 10/18/2021 12:02 PM - Andreas Miuller

- Description updated

This is strange, the actual method getVocRepresentation_L10n_abbreviatedLabel() is never called in cdmlib so | don't understand why an NPE can
be thrown.

#2 - 10/18/2021 02:09 PM - Andreas Miiller
- Status changed from New to Feedback
- Assignee changed from Andreas Miiller to Andreas Kohlbecker

- % Done changed from 0 to 30

| fixed the NPE so it does not throw an exception anymore. However, we need to discuss how the TermDTO should behave. Currently the constructor
only takes the vocabulary.uuid and therefor no representations for vocabulary are available. Do we need those?
As said before the method is never called directly in cdmlib. Only jason seems to call it during serealization. If none of the webservice users(probably
only the dataportal) needs the label we should mybe remove this method.

This issue came with commit cdmlib:71559ffe9c (KL, 2021-09-15) which removed vocRepresentations from the termDTO.

KL + AK can you please both check if you think the vocabulary representation is always needed in this DTO or only if it is explicitly set via
setVocabularyDto(TermVocabularyDto vocabularyDto) method or by using the factory method fromTerm(...)?

| give this ticket first to AK for check if the method is needed at all. If yes, we should have some tests that guarantee that voc labels are available in
the context where it is needed.

#3 - 10/18/2021 03:59 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Katja Luther

this method is only used in the TaxEditor:
eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/search/facet/term/TermSearchResult. java

facets.add (new Facet (((TermDto)content) .getVocRepresentation_L10n (), termType!=null?termType.getLabel () :null))

’

thus passing the ticket to you Katja

#4 - 10/19/2021 03:21 PM - Andreas Miiller
| checked advance search on test servers and it works again: http:/test.e-taxonomy.eu/dataportal/preview/euromed/cdm_dataportal/search

#5 - 10/21/2021 09:30 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Kohlbecker

Added the vocDto to termDto when creating the termDto because the voc representations are needed for the term search. please review, if everything
else still works. Already tested the advanced search for e+m

#6 - 10/26/2021 10:49 AM - Andreas Kohlbecker
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Kohlbecker to Katja Luther

1. | think adding the VocDto to the termDTOs bloats the reponses with a lot of redundant information. In most cases the terms returned by
/description/namedAreasinUse.json will belong to the same vocabulary. Adding the vocabulary uuids to the termDTO would be much more
efficient. If needed, we could introduce a TermListDTO which allows for a normalized representation of termDTOs and VocabDTOs.

2. In the reponse of http:/test.e-taxonomy.eu/cdmserver/euromed/description/namedAreasinUse.json the vocabularyDto is always null, so
something is not working as expected here, otherwise this it not really relevant if we agree in not adding the vocDTo to the termDTOs

#7 - 10/26/2021 01:39 PM - Andreas Miiller

- Target version changed from Release 5.45 to Release 5.28

#8 - 10/26/2021 02:49 PM - Katja Luther

- Target version changed from Release 5.28 to Release 5.45

Andreas Kohlbecker wrote:

1. | think adding the VocDto to the termDTOs bloats the reponses with a lot of redundant information. In most cases the terms returned by
/description/namedAreasinUse.json will belong to the same vocabulary. Adding the vocabulary uuids to the termDTO would be much more
efficient. If needed, we could introduce a TermListDTO which allows for a normalized representation of termDTOs and VocabDTOs.

2. In the reponse of http:/test.e-taxonomy.eu/cdmserver/euromed/description/namedAreasinUse.json the vocabularyDto is always null, so
something is not working as expected here, otherwise this it not really relevant if we agree in not adding the vocDTo to the termDTOs

The vocabulary Dto is added in the dao method, so | changed the name of this method to findByTitleAsDtoWithVocDto, actually it is used only for the
term search, where the vocabulary information is needed.

#9 - 10/26/2021 03:39 PM - Andreas Miiller

- Target version changed from Release 5.45 to Release 5.28
#10 - 10/26/2021 03:41 PM - Andreas Miiller

who is now in charge of this ticket?

#11 - 10/26/2021 03:52 PM - Andreas Miiller

In the mentioned method you iterate over all returned dtos and for each you run a query to retrieve the VocDto. This is highly inperformant. As the
vocabulary is usually highly redundant (most terms come from the same voc). Why don't you hold the result in a Map and only run the query for those
vocabularies not yet loaded?

#12 - 10/26/2021 04:33 PM - Andreas Miiller
Andreas Miller wrote:
In the mentioned method you iterate over all returned dtos and for each you run a query to retrieve the VocDto. This is highly inperformant. As

the vocabulary is usually highly redundant (most terms come from the same voc). Why don't you hold the result in a Map and only run the query
for those vocabularies not yet loaded?

| fixed this. Please review.

#13 - 10/26/2021 04:36 PM - Andreas Miiller
- Status changed from Feedback to Resolved

- % Done changed from 30 to 50

I think in general this ticket is fixed as the webservice and TaxEditor do use 2 different methods to initialize the TermDTO (with or without full
vocabulary DTO). So | suggest to close it once KL has reviewed my last changes.

However, it shows the DTO handling is still very chaotic and urgently needs more structure. But this needs to be done in another context | guess.

#14 - 10/27/2021 10:47 AM - Katja Luther
- Status changed from Resolved to Closed

- Assignee changed from Katja Luther to Andreas Miiller
This works as expected.

#15 - 10/27/2021 10:47 AM - Katja Luther
- % Done changed from 50 to 100
